proc app_nivel {num marqueur z} {
global conex
global parametres
    if {$marqueur=="fas"} {
	set lscale {{taille 1 15}}
	set lradio {}
	saisie_variables $num $lscale $lradio
	if {$parametres(fini) == "pasglop"} {return}
	set t $parametres(taille)
    } else {
	lit_masque $num
	set t 0
    }
coco($num) nivel $marqueur $z $t $conex
}


proc app_fas {num} {

global parametres  

set lscale {{taille 1 15}}
set lradio {{premier "ouverture" "fermeture"}}
set parametres(premier) 0 
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}
set t $parametres(taille)
set s $parametres(premier)     

coco($num) fas $t $s
}

proc app_moyenne {num} {
    
global parametres  
    
set lscale {{rayon 1 30 1}}
set lradio {}
set parametres(rayon) 3
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) mean $parametres(rayon)
}

proc app_exponentiel {num} {
    
global parametres  
    
set lscale {{gamma 0.01 2 0.005}}
set lradio {}
set parametres(gamma) 0.1
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) expon $parametres(gamma)
}

proc app_gaussien {num} {
    
global parametres  
    
set lscale {{sigma 0.5 32 0.5}}
set lradio {}
set parametres(sigma) 3
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

set der {0 2}
coco($num) gauss 0 2 $parametres(sigma)
}

proc app_derivgauss {num} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5}}
set lradio {{derivee "Gx" "Gy" "G" "grad_x" "grad_y" "|grad|" "grad_xx" "grad_yy" "grad_xy" "laplacien"}}
set parametres(sigma) 3
set parametres(derivee) 3
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

switch $parametres(derivee) {
    0 {set der {0 0}}
    1 {set der {0 1}}
    2 {set der {0 2}}
    3 {set der {1 0}}
    4 {set der {1 1}}
    5 {set der {1 2}}
    6 {set der {2 0}}
    7 {set der {2 1}}
    8 {set der {2 2}}
    9 {set der {2 3}}
}
coco($num) gauss [lindex $der 0] [lindex $der 1] $parametres(sigma)
}

proc app_derivgauss_reperelocal {num} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5}}
set lradio {{derivee "G" "Gv" "Gvv" "Gtt" "Gvt" "Gvv.Gv" "Gtt.Gv" "Gvt.Gv"}}
set parametres(sigma) 3
set parametres(derivee) 2
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

if {$parametres(derivee) < 5} {
    set ord_derivee $parametres(derivee)
    set pdt_module 0
} else {
    set ord_derivee [expr $parametres(derivee) - 3]
    set pdt_module 1
}
coco($num) gauss_reperelocal $ord_derivee $pdt_module $parametres(sigma)
}


proc app_contour {num type} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5} {seuil_haut 0 25 0.5} {seuil_bas 0 25 0.5}}
set lradio {}
set parametres(sigma) 1.5 
set parametres(seuil_haut) 8
set parametres(seuil_bas) 1
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) cont_$type $parametres(sigma) \
	    $parametres(seuil_haut) $parametres(seuil_bas)
    
}   
     
 proc app_contrastes {num} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5} {gain 0.5 100 0.5}}
set lradio {}
set parametres(sigma) 1.5 
set parametres(gain) 5
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) contrast $parametres(sigma) $parametres(gain)
} 

proc An_diff {num} {
global parametres 

set lscale {{K 1 255 1} {Iterations 1 200 1}}
set lradio {{type "exponentiel" "hyperbolique"}}
set parametres(K) 25 
set parametres(Iterations) 10
set parametres(type) 0
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

    coco($num) diffanise $parametres(type) $parametres(K) $parametres(Iterations)
    update

}

proc App_mean_curve {num} {
global parametres 

set lscale {{Iterations 1 200 1}}
set lradio {}

saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

    coco($num) mean_curve 0.5 $parametres(Iterations)
    update

}

proc app_Hessian {num} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5}}
set lradio {{type "Trace" "Dterminant" "Norme de Frobnius" "Grande valeur propre" "Petite valeur prore"}}
set parametres(sigma) 3.0
set parametres(type) 1 
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) hess_measure $parametres(type) $parametres(sigma)
}

proc app_DiffFlow {num} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5} {pas_aff 2 10 1}}
set lradio {{type "Gradient" "Dir_Grad" "Dir_Isophote" "Premier_Vect_propre" "Second_Vect_propre" "Courbure_principale" "Courbure isophote"}}
set parametres(sigma) 3.0
set parametres(pas_aff) 8
set parametres(type) 1 
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) diff_flow $parametres(sigma) $parametres(type) $parametres(pas_aff)
}

proc app_harris {num} {
    
global parametres  
    
set lscale {{sigma1 0 30 0.5} {sigma2 0.5 30 0.5} {seuil 0 100 1}}
set lradio {{affichage "fonction" "points" "pts+image"}}
set parametres(sigma1) 1 
set parametres(sigma2) 2
set parametres(seuil) 1
set parametres(affichage) 1
saisie_variables $num $lscale $lradio

if {$parametres(fini) == "pasglop"} {return}

coco($num) harris $parametres(sigma1) $parametres(sigma2) $parametres(seuil) $parametres(affichage)
}   

proc app_curv {num} {
    
global parametres  
    
set lscale {{sigma 0.5 30 0.5} {seuil 0 100 1}}
set lradio {{affichage "fonction" "points" "pts+image"}}
set parametres(sigma) 1
set parametres(seuil) 10
set parametres(affichage) 1
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) curv $parametres(sigma) $parametres(seuil) $parametres(affichage)
}   

proc Max_reg {num} {
global conex

coco($num) maxreg $conex
}

proc Watershed {num} {
global conex

coco($num) lpe $conex
}

proc app_dyn {num} {
global conex   
global parametres  
    
set lscale {{dynamique 1 50 1}}
set lradio {}
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) fil_dyn $parametres(dynamique) $conex
}

proc Feat_NLM_LJ_gene_LR {num} {
global parametres

set lscale {{taille_fenetre 3 31 1} {ordre_derivation 0 2 1} {nombre_echelles 1 6 1} {sigma_initial 1.0 8 0.5} {facteur_bruit 0.1 2 0.05}}
set lradio {}
set parametres(taille_fenetre) 13 
set parametres(ordre_derivation) 2 
set parametres(nombre_echelles) 1
set parametres(sigma_initial) 1.0
set parametres(facteur_bruit) 0.25 
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) NLM_LR $parametres(taille_fenetre) $parametres(ordre_derivation) $parametres(nombre_echelles) $parametres(sigma_initial) $parametres(facteur_bruit)

}

proc Haar_Filter {num} {
    
global parametres  
    
set lscale {{largeur 6 60 6} {hauteur 6 60 6}}
set lradio {{forme "S" "Dx" "Dy" "Dxx" "Dyy" "Dxy"}}
set parametres(largeur) 48
set parametres(hauteur) 30
set parametres(forme) 3
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

coco($num) haar_filt $parametres(largeur) $parametres(hauteur) $parametres(forme)

}
