proc print_histo {num} {

set win .histog_$num
if {[winfo exists $win]} {
mise_a_jour_histo $num
} else {	
 toplevel $win
 set titre "Histogramme"                    
 wm title $win $titre
 canvas $win.plot -width 350 -height 350 -bg white
 trace_histo $num
 button $win.button -text "Fermer" -command "destroy $win"
 pack $win.plot  $win.button -side top
 }
} 

proc print_histo_cumule {num} {

set win1 .histog_cumul_$num
if {[winfo exists $win1]} {
mise_a_jour_histo_cumule $num
} else {
toplevel $win1
set titre "Histogramme cumul"                    
wm title $win1 $titre

canvas $win1.plot -width 350 -height 350 -bg white  
trace_histo_cumule $num
button $win1.button -text "Fermer" -command "destroy $win1"
pack $win1.plot  $win1.button -side top
}
}

proc trace_histo {num} {
global decal_histo

set chaine [coco($num) histo]
set hist($num) [split $chaine]

set win .histog_$num
set decal_histo 60

set max [lindex $hist($num) 256]
set factor [expr double(256/double($max))]
tracerAxeX $win.plot $decal_histo [expr 256+$decal_histo] [expr 256+$decal_histo] [expr 256+$decal_histo] 4
tracerAxeY $win.plot $decal_histo [expr 256+$decal_histo] $decal_histo $decal_histo 4 $max 
for {set i 0} {$i < 256} {incr i} {
  set n [lindex $hist($num) $i]
  set val [expr int(double($n)*$factor)]
  $win.plot create line [expr $i + $decal_histo] [expr 256+$decal_histo] [expr $i + $decal_histo] [expr 256+$decal_histo-$val] -fill green
 }
}

proc trace_histo_cumule {num} {
global decal_histo

set chaine [coco($num) histo_cumule]
set hist_cum($num) [split $chaine]

set win1 .histog_cumul_$num
set decal_histo 60
set w [image width toto($num)]
set h [image height toto($num)]
set max [lindex $hist_cum($num) 256]
set factor [expr double(256/double($max))]
tracerAxeX $win1.plot $decal_histo [expr 256+$decal_histo] [expr 256+$decal_histo] [expr 256+$decal_histo] 4
tracerAxeY_normalise $win1.plot $decal_histo [expr 256+$decal_histo] $decal_histo $decal_histo 4 
for {set i 0} {$i < 256} {incr i} {
    set n [lindex $hist_cum($num) $i]
    set val [expr int(double($n)*$factor)]
    $win1.plot create line [expr $i + $decal_histo] [expr 256+$decal_histo] [expr $i + $decal_histo] [expr 256+$decal_histo-$val] -fill violet
}
}

proc tracerAxeX {fenetre x0 y0 xfin yfin  n} {

    $fenetre create line $x0 $y0 $xfin $yfin -fill black -arrow last 
	for {set i 0} {$i < $n} {incr i} {
		set valeur [expr $i*256/$n]
   
		set x0n [expr $x0 +(($xfin -$x0)*$i/$n)]
		set y0n [expr $y0 +(($yfin -$y0)*$i/$n) -4]
		set xfinn [expr $x0 +(($xfin -$x0)*$i/$n)]
		set yfinn [expr $y0 +(($yfin -$y0)*$i/$n) +4]
		$fenetre create line $x0n $y0n $xfinn $yfinn  -fill blue
		set xtext [expr $x0n]
		set ytext [expr $y0n+14]
		$fenetre create text $xtext $ytext -text $valeur
	}
 
}

proc tracerAxeY {fenetre x0 y0 xfin yfin n maximum} {

    $fenetre create line $x0 $y0 $xfin $yfin -fill black -arrow last
    for {set i 0} {$i < $n} {incr i} {
		set valeur [expr $i*$maximum/$n]
      
		set x0n [expr $x0 +(($xfin -$x0)*$i/$n) -4]
		set y0n [expr $y0 +(($yfin -$y0)*$i/$n)]
		set xfinn [expr $x0 +(($xfin -$x0)*$i/$n) +4]
		set yfinn [expr $y0 +(($yfin -$y0)*$i/$n)]
		$fenetre create line $x0n $y0n $xfinn $yfinn  -fill blue 
		set xtext [expr $x0n-14]
		set ytext [expr $y0n]
		$fenetre create text $xtext $ytext -text $valeur
	}
}

proc tracerAxeY_normalise {fenetre x0 y0 xfin yfin n} {

    $fenetre create line $x0 $y0 $xfin $yfin -fill black -arrow last
    for {set i 0} {$i < $n} {incr i} {
		set valeur [expr double(double($i)/double($n))]
      
		set x0n [expr $x0 +(($xfin -$x0)*$i/$n) -4]
		set y0n [expr $y0 +(($yfin -$y0)*$i/$n)]
		set xfinn [expr $x0 +(($xfin -$x0)*$i/$n) +4]
		set yfinn [expr $y0 +(($yfin -$y0)*$i/$n)]
		$fenetre create line $x0n $y0n $xfinn $yfinn  -fill blue
		set xtext [expr $x0n-14]
		set ytext [expr $y0n]
		$fenetre create text $xtext $ytext -text $valeur
	}
}

proc egalise {num} {

coco($num) egaliser
mise_a_jour_histo $num
mise_a_jour_histo_cumule $num
}

proc etirement_min_max {num} {

set chaine [coco($num) histo]
set hist($num) [split $chaine]

set bascule 0
for {set i 0} {$i < 256} {incr i} {
	set n [lindex $hist($num) $i]
	if {$n > 0} {
		if {$bascule == 0} {
			set min $i
		}
		set bascule 1
		set max $i
	}
}
#puts "min=$min"
#puts "max=$max"
set a [expr double(double(255)/double($max - $min))]
set b [expr double(double(-255 *$min)/double($max - $min))]
#puts "a=$a"
#puts "b=$b"
coco($num) transaffine $a $b
mise_a_jour_histo $num
mise_a_jour_histo_cumule $num
}

proc etirement_plow_phigh {num plow phigh} {

set chaine [coco($num) histo]
set hist($num) [split $chaine]
set w [image width toto($num)]
set h [image height toto($num)]

set bascule1 0
set bascule2 0

set compt 0
for {set i 0} {$i < 256} {incr i} {
	set n [lindex $hist($num) $i]
	incr compt $n
	if {[expr double($compt)/double($w*$h)] > $plow} {
		if {$bascule1 == 0} {
			set min $i
		}
		set bascule1 1
	}
	if {[expr double($compt)/double($w*$h)] >= $phigh} {
		if {$bascule2 == 0} {
			set max $i
	}
	
		set bascule2 1
	}	
}
#puts "min=$min"
#puts "max=$max"
set a [expr double(double(255)/double($max - $min))]
set b [expr double(double(-255 *$min)/double($max - $min))]
#puts "a=$a"
#puts "b=$b"
coco($num) transaffine $a $b
mise_a_jour_histo $num
mise_a_jour_histo_cumule $num
}

proc plow_phigh {num} {

global parametres
set lscale {{plow 0 1 0.1} {phigh 0 1 0.1}}
set lradio {}
saisie_variables $num $lscale $lradio
if {$parametres(fini) == "pasglop"} {return}

etirement_plow_phigh $num $parametres(plow) $parametres(phigh)
}

proc mise_a_jour_histo {num} {

set win .histog_$num
if {[winfo exists $win]} {
	
	$win.plot addtag fonction all
	$win.plot delete fonction
	trace_histo $num
}
}

proc mise_a_jour_histo_cumule {num} {

set win1 .histog_cumul_$num
if {[winfo exists $win1]} {
	
	$win1.plot addtag fonction all
	$win1.plot delete fonction
	trace_histo_cumule $num
}
}

proc seuil_simple {num} {

set win .histog_$num
if {![winfo exists $win]} {
print_histo $num
}
bind $win.plot <Button-1> "seuil_souris $num %x"
 
}

proc seuil_souris {num xpos} {

global decal_histo
set win .histog_$num
	set th [expr $xpos - $decal_histo]
puts "Seuil = $th"
catch {$win.plot delete ligne_seuil}
$win.plot create line $xpos $decal_histo $xpos [expr 256+$decal_histo] -fill red -tag ligne_seuil
coco($num) seuil1 $th
bind $win.plot <Button-1>  "seuil_souris $num %x"
}

proc seuil_double {num} {

set win .histog_$num
if {![winfo exists $win]} {
print_histo $num
}
bind $win.plot <Button-1> "debutfenetre_histo $num %x"
bind $win.plot <B1-Motion> "dessinefenetre_histo $num %x"
bind $win.plot <ButtonRelease-1> "finfenetre_histo $num %x"
}

proc debutfenetre_histo {num x} {

global box_histo
global th_min
global decal_histo

set th_min [expr $x - $decal_histo]
catch {.histog_$num.plot delete $box_histo(last)}
set box_histo(anchor) [list $x $decal_histo]
catch {unset box_histo(last)}
}

proc dessinefenetre_histo {num x} {

global box_histo
global decal_histo

catch {.histog_$num.plot delete $box_histo(last)}
set box_histo(last) [eval {.histog_$num.plot create rect} $box_histo(anchor) \
          {$x [expr 256+$decal_histo] -tag box_histo -outline red}]
}

proc finfenetre_histo {num x} {

global th_min
global decal_histo

set th_max [expr $x - $decal_histo]

if {$th_min > $th_max} {
 set tempo $th_max
 set th_max $th_min
 set th_min $tempo
}
puts "Seuil 1 = $th_min"
puts "Seuil 2 = $th_max"
coco($num) seuil2 $th_min $th_max
set win .histog_$num
#bind $win.plot <Button-1> {}
#bind $win.plot <B1-Motion> {}
#bind $win.plot <ButtonRelease-1> {}
}
