#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tk.h>
#include "photo.hh"
#include "Image.hh"
#include "filtre.hh"
#include "morfo.hh"
#include "histo.hh"
#include "contour.hh"
#include "feature.hh"

/* stockage des infos d'image */

Tk_PhotoImageBlock *blockPtr;

static int TAB[NMAX][NMAX];
static int taille;

template <class T> struct infoimage{
  Image<int> img;
  Tk_PhotoHandle handle;
};

/* Conversion en une image Inti avec allocation eventuelle */

Image<int> tkimage2Inti(Tk_PhotoImageBlock *tkim){
       int i,j;
       int *pixrim;
       unsigned char *pixtk;
       int tw=tkim->width;
       int th=tkim->height;
       Image<int> p(tw,th);

       pixrim=p.PI();
       for (j=0;j<tkim->height;j++) {
          pixtk=tkim->pixelPtr + tkim->pitch*j;
          for (i=0;i<tkim->width;i++) {
              int n = (int)((*(pixtk+tkim->offset[0]) + *(pixtk+tkim->offset[1]) + *(pixtk+tkim->offset[2]))/3);
              *pixrim = n;
              pixtk+=tkim->pixelSize;pixrim++;
          }
       }
       return p;
}

/* conversion en une image tk avec allocation eventuelle */

Tk_PhotoImageBlock *Inti2tkimage(Image<int>& pp,Tk_PhotoImageBlock *tkim) {
       unsigned char *tempotk;
       int *tempoplan;
       int i;
       if (tkim == NULL) {
              tkim = (Tk_PhotoImageBlock *)malloc(sizeof(Tk_PhotoImageBlock));
	      tkim->pixelPtr = NULL;
       }

       tkim->width=pp.PW();
       tkim->height=pp.PL();
       tkim->pixelSize=3;
       tkim->pitch=tkim->width*tkim->pixelSize;
       tkim->offset[0]=0;
       tkim->offset[1]=1;
       tkim->offset[2]=2;

       if (tkim->pixelPtr == NULL) {
	 tempotk= tkim->pixelPtr=(unsigned char *)malloc(tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       } else {
	 tempotk= tkim->pixelPtr=(unsigned char *)realloc(tkim->pixelPtr,tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       }
       tempoplan=pp.PI();
       for (i=0;i<tkim->width*tkim->height;i++) {
	 if (*tempoplan < 256) {
       	*tempotk = *(tempotk+tkim->offset[1]) = *(tempotk+tkim->offset[2]) = (unsigned char)(*tempoplan);
	 } else {
	   int c=(*tempoplan)-500;
	   *(tempotk+tkim->offset[0]) = 255*(c%2); 
	   *(tempotk+tkim->offset[1]) = 255*((c/2)%2);
	   *(tempotk+tkim->offset[2]) = 255*((c/4)%2);}
	tempoplan++;
	tempotk+=tkim->pixelSize;
       }
       return tkim;
}

void freetkim(Tk_PhotoImageBlock *tkim) {
       free(tkim->pixelPtr);
       free(tkim);
}



int Inti_cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int>* cdata;
       cdata  = (infoimage<int>*) clientData;
       
       float x,y,t1,t2;
       int a,b,c;
       char *fich;
       int chg=1;
       int* histo;
       int* histo_cumule;
       char *numb;
       float x1,x2;
       
       if (strncmp(argv[1],"change_bord",10) == 0) {a = atoi(argv[2]);
       ChangeBord(a);chg=0;}
       else
       if (strcmp(argv[1],"set_size") == 0) {a = atoi(argv[2]);
       taille = a;chg=0;}
       else 
       if (strcmp(argv[1],"setvaluemasque") == 0) {
       a = atoi(argv[2]);b = atoi(argv[3]);c = atoi(argv[4]);
       TAB[a+taille][b+taille]=c;chg=0;}
        else
	  if (strcmp(argv[1],"filtre") == 0) {cdata->img.Empile("filtre"); FiltreFixe(cdata->img,argv[2]);}
        else
       if (strcmp(argv[1],"lineaire") == 0) {cdata->img.Empile("lineaire");  x = atof(argv[3]);
                                        FiltreMasque(cdata->img,argv[2],TAB,x);} 
       else
	 if (strcmp(argv[1],"mean")==0) {
	   cdata->img.Empile("mean");
	   a = atoi(argv[2]);
	   Mean(cdata->img,a);
	 }
       else
	 if (strcmp(argv[1],"expon")==0) {
	   cdata->img.Empile("expon");
	   x = atof(argv[2]);
	   Exponential(cdata->img,x);
	 }
       else
	 if (strcmp(argv[1],"gauss")==0) {
	   cdata->img.Empile("gauss");
	   x = atof(argv[4]);a = atoi(argv[2]);b = atoi(argv[3]);
	   Gaussian(cdata->img,a,b,x);
	 }
       else
	 if (strcmp(argv[1],"gauss_reperelocal")==0) {
	   cdata->img.Empile("gauss_reperelocal");
	   x = atof(argv[4]);a = atoi(argv[2]);b = atoi(argv[3]);
	   Display_RI_LJ(cdata->img,a,b,x);
	 }
	 else 
	   if (strcmp(argv[1],"contrast")==0) {
	     cdata->img.Empile("contrast");
	   x = atof(argv[2]); y = atof(argv[3]);
	   Contrast_enhance(cdata->img,x,y);
	   }
       else
	      if (strcmp(argv[1],"NLM_LR") == 0) {  
	      cdata->img.Empile("NLM_LR");
              a = atoi(argv[2]); b = atoi(argv[3]);
	      c = atoi(argv[4]);
              x = atof(argv[5]);y = atof(argv[6]);
	      NLM_LJ_generic (cdata->img,a,b,c,x,y);}
       else
       if (strcmp(argv[1],"cont_marr") == 0) { cdata->img.Empile("cont_marr"); x = atof(argv[2]);t1 = atof(argv[3]);
                                           t2 = atof(argv[4]);
                                        Marr_Hildreth(cdata->img,x,t1,t2);} 
       else
       if (strcmp(argv[1],"cont_canny") == 0) { cdata->img.Empile("cont_canny"); x = atof(argv[2]);t1 = atof(argv[3]);
                                           t2 = atof(argv[4]);
                                        Canny(cdata->img,x,t1,t2);}
       else
       if (strcmp(argv[1],"cont_reperelocal") == 0) { cdata->img.Empile("cont_reperelocal"); x = atof(argv[2]);t1 = atof(argv[3]);
                                           t2 = atof(argv[4]);
                                        Contours_RepereLocal(cdata->img,x,t1,t2);}
       else
       if (strcmp(argv[1],"cc") == 0)
	 { cdata->img.Empile("cc"); Comp_connexe(cdata->img); }
       else
       if (strcmp(argv[1],"fctdist") == 0)
	 {cdata->img.Empile("fctdist"); FctDistance(cdata->img,argv[2]);}
       else
	if (strcmp(argv[1],"fas") == 0) { cdata->img.Empile("fas"); a = atoi(argv[2]);
                                         b = atoi(argv[3]);
                                        FAS(cdata->img,a,b);}
       else
       if (strcmp(argv[1],"maxreg") == 0) { cdata->img.Empile("maxreg"); a = atoi(argv[2]);
                                        Max_regionaux(cdata->img,a);}
       else 
	 if (strcmp(argv[1],"eroult") == 0) {a = atoi(argv[2]);cdata->img.Empile("eroult");
	Ero_ult(cdata->img,a);}
        else 
	 if (strcmp(argv[1],"lpe") == 0) {a = atoi(argv[2]);cdata->img.Empile("lpe");
	   LPE(cdata->img,a);}
        else
       if (strcmp(argv[1],"fil_dyn") == 0) { cdata->img.Empile("fil_dyn"); a = atoi(argv[2]); b = atoi(argv[3]);
	 Filtrage_dynamique(cdata->img,a,b);}
	else
        if (strcmp(argv[1],"maxpropag") == 0) { cdata->img.Empile("maxpropag");
	  a = atoi(argv[2]);
	MaxPropag(cdata->img,a);}
       else
	 if (strcmp(argv[1],"morpho") == 0) { 
	   cdata->img.Empile("morpho"); 
	   a = atoi(argv[3]);
	   Morphobase(cdata->img,argv[2],TAB,a);}
       else
	 if (strcmp(argv[1],"nivel") == 0) {
	   cdata->img.Empile("nivel"); 
	   x = atof(argv[3]);
	   a = atoi(argv[4]);
	   b = atoi(argv[5]);
	   Nivellement(cdata->img,argv[2],TAB,x,a,b);}
       else
	 if (strcmp(argv[1],"rang") == 0) { 
	   cdata->img.Empile("rang"); 
	   x = atof(argv[2]);
	   Filtre_Rang(cdata->img,TAB,x);}
       else
	 if (strcmp(argv[1],"seuil") == 0) { 
	   cdata->img.Empile("seuil"); 
	   a = atoi(argv[2]);
	   cdata->img = cdata->img.Image_seuil(a);}
       else
	 if (strcmp(argv[1],"levelsets") == 0) { 
	   cdata->img.Empile("levelsets"); 
	   a = atoi(argv[2]);
	   cdata->img = cdata->img.Image_levelsets(a);}
       else
	 if (strcmp(argv[1],"hess_measure")==0) {
	   cdata->img.Empile("hess_measure"); 
	   x = atof(argv[2]);a = atoi(argv[3]);
	   Hessian_measures(cdata->img,a,x);
	 }
         else
	 if (strcmp(argv[1],"diff_flow")==0) {
	   cdata->img.Empile("diff_flow"); 
	   x = atof(argv[2]);a = atoi(argv[3]);
	   b = atoi(argv[4]);
	   Diff_Flow_Measures(cdata->img,x,a,b);
	 }
       else
	 if (strcmp(argv[1],"haar_filt")==0) {
	   cdata->img.Empile("haar_filt"); 
	   a = atoi(argv[2]);b = atoi(argv[3]);
	   c = atoi(argv[4]);
	   Haar_Filters(cdata->img,a,b,c);
	 }
	 else
	 if (strcmp(argv[1],"curv")==0) {
	   cdata->img.Empile("curv");
	   x = atof(argv[2]);
	   b = atoi(argv[3]);c = atoi(argv[4]);
	   Morpho_interest(cdata->img,x,b,c);
	 }
	   else
	 if (strcmp(argv[1],"harris")==0) {
	   cdata->img.Empile("harris");
	   x = atof(argv[2]);y = atof(argv[3]);
	   b = atoi(argv[4]);c = atoi(argv[5]);
	   Harris(cdata->img,x,y,b,c);
	 }
	 else
	   if (strcmp(argv[1],"diffanise") == 0) {
	     cdata->img.Empile("diffanise");
 x = atof(argv[3]); b = atoi(argv[4]);a = atoi(argv[2]);
       Diffusion_anisotrope(cdata->img,a,x,b);}
        else
	  if (strcmp(argv[1],"mean_curve") == 0) { 
	    cdata->img.Empile("mean_curve");
	    x = atof(argv[2]); b = atoi(argv[3]);
	  Mean_curvature(cdata->img,x,b);}
	 else 
	   if (strncmp(argv[1],"translat",6) == 0) { a = atoi(argv[2]);b = atoi(argv[3]);
	   if ((a != 0) | (b != 0)) {cdata->img.Empile("translat");  cdata->img = cdata->img.Image_translat(Vecteur(a,b));} }
	   else   
	     if (strncmp(argv[1],"save",7) == 0) { fich = argv[2];
	     cdata->img.Imagetopgm(fich);chg=0;}
       else
	if (strcmp(argv[1],"histo") == 0) {
	  histo = (int*)calloc(257,sizeof(int));
	  histogramme(cdata->img,histo);
	  numb = (char*)malloc(10*sizeof(char));
	  for (int i=0;i<257;i++) {
		sprintf(numb,"%d",histo[i]);
		Tcl_AppendElement(interp,numb);
	  }
	  chg=0;
	}
  else
	if (strcmp(argv[1],"histo_cumule") == 0) {
	  histo_cumule = (int*)calloc(257,sizeof(int));
	  Histogramme_Cumule(cdata->img,histo_cumule);
	  numb = (char*)malloc(10*sizeof(char));
	  for (int i=0;i<257;i++) {
		sprintf(numb,"%d",histo_cumule[i]);
		Tcl_AppendElement(interp,numb);
	  }
	  chg=0;
	}
  
  else
	if (strcmp(argv[1],"transaffine") == 0) {
	  cdata->img.Empile("transaffine"); 
	  x1 = atof(argv[2]);x2 = atof(argv[3]);
	  TransAffine(cdata->img,x1,x2);
	}
   else
	if (strcmp(argv[1],"egaliser") == 0) {
	  cdata->img.Empile("egaliser"); 
	  Egalisation(cdata->img); }
	else
	  if (strcmp(argv[1],"seuil1") == 0) { 
	    if (cdata->img.DerniereOperation() && (strcmp(cdata->img.DerniereOperation(),"seuil1")==0))
		{
		  cdata->img.DepileArriere();
		}
	    a = atoi(argv[2]);
	    cdata->img.Empile("seuil1"); 
	    SeuilSimple(cdata->img,a);
	  }
	  else
	    if  (strcmp(argv[1],"defaire") == 0) {
	      cdata->img.DepileArriere();
	    }
	    else 
	      if  (strcmp(argv[1],"refaire") == 0) {
	      cdata->img.DepileAvant();
	      }
    else
	if (strcmp(argv[1],"seuil2") == 0) { 
	  if (cdata->img.DerniereOperation() && (strcmp(cdata->img.DerniereOperation(),"seuil2")==0))
		{
		  cdata->img.DepileArriere();
		}
	  cdata->img.Empile("seuil2"); 
	  a = atoi(argv[2]);b = atoi(argv[3]);
	  SeuilDouble(cdata->img,a,b);
	}  
	     if (chg) {
       blockPtr=Inti2tkimage(cdata->img,blockPtr);
       Tk_PhotoPutBlock(cdata->handle, blockPtr, 0, 0, blockPtr->width, blockPtr->height);
       }
        return TCL_OK;       
}

int img_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int> *cdata;
       Tk_PhotoImageBlock blockPtr;
       char *error_msg;

       cdata = (infoimage<int>*) clientData;
     if (argc != 2) {
                sprintf(error_msg,"Usage: Imgnew <image>");
                Tcl_SetResult(interp,error_msg,TCL_VOLATILE);
		return TCL_ERROR;
	}
   cdata->handle=Tk_FindPhoto(interp,argv[1]);
   Tk_PhotoGetImage(cdata->handle, &blockPtr);
   cdata->img=tkimage2Inti(&blockPtr);
 return TCL_OK;
}


/* creation d'une image de type Inti */
/* Intinew <nomimage> <nomcommanderet> */

void init_retcc() {
blockPtr = NULL;
}

int Inti_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int> *cdata;
       char *error_msg;

	if (argc != 2) {
                sprintf(error_msg,"Usage: Intinew <nomcommande>");
                Tcl_SetResult(interp,error_msg,TCL_VOLATILE);
		return TCL_ERROR;
	}
         cdata = new infoimage<int>;
         Tcl_CreateCommand(interp, "Imgnew", img_new, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
         Tcl_CreateCommand(interp, argv[1], Inti_cmd, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
         return TCL_OK;
}


